{% load misc %}
<!DOCTYPE html>
<html>
<head>
    <title>Insult API</title>
    <style>
td, th
{
    border: 1px solid gray;
    padding: 0.25em;
}
table
{
    border-collapse: collapse;
}
th
{
    background-color: #edc;
}
table.api_params > tbody > tr td:first-child
{
    font-family: monospace;
    font-weight: bold;
}
table .fixed_string, .http_status
{
    font-family: monospace;
}
span.none
{
    font-style: oblique;
    color: #555;
}

.api_url
{
    font-family: monospace;
    font-size: larger;
}
a.api_url:active, a.api_url:visited, a.api_url:link {
    color: black;
    text-decoration: none;
    border-bottom: 1px dotted black;
}
a.api_url:hover {
    color: black;
    border-bottom: 1px solid black;
}

.section a:active, .section a:visited, .section a:link, .section a:hover {
    color: black;
    text-decoration: none;
}

.section a:hover:after {
    content: "¶";
}


.api_url_section {
    border-top: 1px solid gray;
    padding-top: 1ex;
}
    </style>
</head>
<body>
{% section h1 %}Insult API{% endsection %}

{% section h2 %}Formats{% endsection %}

<table>
    <thead><tr><th>Format</th><th>Content Type</th></tr></thead>
    <tbody>
        {% for format in formats %}
            <tr><td class="fixed_string">{{ format.name }}</td><td>{{ format.content_type }}</td></tr>
        {% endfor %}
    </tbody>
</table>

{% section h2 %}Explore{% endsection %}

<p>You can play with the various parameters with the <a href="{% url 'insult:explore' %}">API Explorer</a>.</p>

{% section h2 %}Responses{% endsection %}

<p>In case of a successful request, the API will return a
<span class="http_status">200</span> page with the insult formatted in the
requested format.</p>

<p>In case of incorrect parameters, the API will return a
<span class="http_status">400</span> error, the body of the response depends on
the format.</p>

{% section h3 %}JSON{% endsection %}

<p>A successful responses will contain the following data:</p>

<table>
    <thead><tr><th>Name</th><th>Value</th></tr></thead>
    <tbody>
        <tr><td class="parameter">error</td><td><span class="fixed_string">false</span></td></tr>
        <tr><td class="parameter">insult</td><td>The generated string</td></tr>
        <tr><td class="parameter">args</td><td>A dictionary listing the parameters used to generate the output, including default values.</td></tr>
    </tbody>
</table>

<p>A failed response will have the following:</p>

<table>
    <thead><tr><th>Name</th><th>Value</th></tr></thead>
    <tbody>
        <tr><td class="parameter">error</td><td><span class="fixed_string">true</span></td></tr>
        <tr><td class="parameter">error_message</td><td>A brief message describing the reason for the error.</td></tr>
    </tbody>
</table>

{% section h2 %}Methods{% endsection %}
{% section h3 %}GET{% endsection %}

{% section h4 class='section api_url_section' %}/insult{% endsection %}
{% api_url_link 'insult:api_txt' %}
<p>Generates an insult in plain text.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
        <tr><td class="parameter">template</td><td>Insult template</td><td class="fixed_string">{{ default_template }}</td></tr>
        <tr><td class="parameter">who</td><td>Person to insult, changes the template to third person singular.</td><td class="fixed_string"><span class="none">None</span></td></tr>
        <tr><td class="parameter">plural</td><td>If present (with <span class="fixed_string">who</span>) changes the template to third person plural.</td><td class="fixed_string"><span class="none">None</span></td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/insult.<em>format</em>{% endsection %}
{% api_url_link 'insult:api' format='html' %}
<p>Generates an insult in one of the supported formats.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
        <tr><td class="parameter">template</td><td>Insult template</td><td class="fixed_string">{{ default_template }}</td></tr>
        <tr><td class="parameter">who</td><td>Person to insult, changes the template to third person singular.</td><td class="fixed_string"><span class="none">None</span></td></tr>
        <tr><td class="parameter">plural</td><td>If present (with <span class="fixed_string">who</span>) changes the template to third person plural.</td><td class="fixed_string"><span class="none">None</span></td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/<em>lang</em>/insult.<em>format</em>{% endsection %}
{% api_url_link 'insult:api_lang' format='html' lang='en' %}
<p>Generates an insult in a fixed language.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">template</td><td>Insult template</td><td class="fixed_string">{{ default_template }}</td></tr>
        <tr><td class="parameter">who</td><td>Person to insult, changes the template to third person singular.</td><td class="fixed_string"><span class="none">None</span></td></tr>
        <tr><td class="parameter">plural</td><td>If present (with <span class="fixed_string">who</span>) changes the template to third person plural.</td><td class="fixed_string"><span class="none">None</span></td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/adjective{% endsection %}
{% api_url_link 'insult:api_adjective_txt' %}
<p>Generates a single adjective in plain text.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/adjective.<em>format</em>{% endsection %}
{% api_url_link 'insult:api_adjective' format='html' %}
<p>Generates a single adjective in one of the supported formats.</p>
<table class="api_params">
    <thead><tr><th>Name</th><th>Description</th><th>Default</th></tr></thead>
    <tbody>
        <tr><td class="parameter">lang</td><td>Language</td><td class="fixed_string">{{ default_language }}</td></tr>
    </tbody>
    <caption>Parameters</caption>
</table>

{% section h4 class='section api_url_section' %}/<em>lang</em>/adjective.<em>format</em>{% endsection %}
{% api_url_link 'insult:api_adjective_lang' format='html' lang='en' %}
<p>Generates a single adjective in a fixed language.</p>

</body>
</html>
